name: deleteapp

on:
  workflow_dispatch:
    inputs:
      a_app_region:
        type: string
        description: "Application Region e.g. EU"
        default: EU  
      b_cloudlet:
        type: choice
        options:
          - Amsterdam-OTC
          - Hamburg
          - Leipzig
          - Munich
          - Berlin
          - Frankfurt
          - Magdeburg-OTC
          - Bonn
          - Magdeburg
        description: "Cloudlet e.g. EU.small"
        default: Munich
        required: true  

env:
  EDGEXR_PLATFORM_USERNAME: ${{ secrets.EDGEXR_PLATFORM_USERNAME }}
  EDGEXR_PLATFORM_PASSWORD: ${{ secrets.EDGEXR_PLATFORM_PASSWORD }}
  APP_REGION: ${{ inputs.a_app_region }}
  CLOUDLET: ${{ inputs.b_cloudlet }}

jobs:
  build:
    runs-on: ubuntu-22.04

    steps:
      -
        name: Repository meta
        id: repository
        run: |
          registry=${{ github.server_url }}
          registry=${registry##http*://}
          echo "registry=${registry}" >> "$GITHUB_OUTPUT"
          echo "registry=${registry}"
          repository="$(echo "${{ github.repository }}" | tr '[:upper:]' '[:lower:]')"
          echo "repository=${repository}" >> "$GITHUB_OUTPUT"
          echo "repository=${repository}"
      -
        name: Docker meta
        uses: docker/metadata-action@v5
        id: docker
        with:
          images: ${{ steps.repository.outputs.registry }}/${{ steps.repository.outputs.repository }}
      - 
        name: Install Dependencies
        run: |
          sudo apt update
          sudo apt install -y curl jq
      -
        name: Delete Edge Connect App Instance
        run: |
          set -e
          echo login 
          EDGEXR_TOKEN="$(curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/login -H 'Content-Type: application/json' --data '{"password": "'${EDGEXR_PLATFORM_PASSWORD}'","username": "'${EDGEXR_PLATFORM_USERNAME}'"}' -sSf | jq -r .token)"

          DELETEAPPINSTANCE_JSON=$(cat <<EOF
          {
            "region": "${APP_REGION}",
            "appinst": {
              "key": {
                "organization": "edp-developer-framework",
                "name": "$(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')-instance",
                "cloudlet_key": {
                  "organization": "TelekomOP",
                  "name": "${CLOUDLET}"
                }
              },
              "app_key": {
                "organization": "edp-developer-framework",
                "name": "$(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')",
                "version": "${{ steps.docker.outputs.version }}"
              }
            }
          }
          EOF
          )

          echo $DELETEAPPINSTANCE_JSON

          echo delete app instance
          curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/auth/ctrl/DeleteAppInst -H 'Content-Type: application/json' -H "Authorization: Bearer $EDGEXR_TOKEN" -S --data "$DELETEAPPINSTANCE_JSON" --fail-with-body || true
      -
        name: Delete Edge Connect App
        run: |
          set -e
          echo login 
          EDGEXR_TOKEN="$(curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/login -H 'Content-Type: application/json' --data '{"password": "'${EDGEXR_PLATFORM_PASSWORD}'","username": "'${EDGEXR_PLATFORM_USERNAME}'"}' -sSf | jq -r .token)"

          DELETEAPP_JSON=$(cat <<EOF
          {
            "App": {
              "key": {
                "organization": "edp-developer-framework",
                "name": "$(echo ${{ steps.repository.outputs.repository }} | sed -e 's|^.*/||')",
                "version": "${{ steps.docker.outputs.version }}"
              }
            },
            "Region": "${APP_REGION}"
          }
          EOF
          )

          echo $DELETEAPP_JSON

          echo delete app
          curl -X POST https://hub.apps.edge.platform.mg3.mdb.osc.live/api/v1/auth/ctrl/DeleteApp -H 'Content-Type: application/json' -H "Authorization: Bearer $EDGEXR_TOKEN" -S --data "$DELETEAPP_JSON" --fail-with-body
